/*
    EventCallback.h 
    Copyright (c) Donatien Garnier 2012
    donatien.garnier@appnearme.com
    http://www.appnearme.com/
*/


#ifndef EVENTCALLBACK_H_
#define EVENTCALLBACK_H_

#include "NFCEvent.h"

#include "munfc/core/fwk.h"
#include "munfc/target/event.h"

class EventCallback
{
protected:
  EventCallback();

  void init( void (*fn)(target_event_callback, void*) ); //Callable by MuNFC

  void attach(void (*fn)(NFCEvent, void*), void* arg);

  template <class T>
  void attach(T* inst, void (T::*member)(NFCEvent))
  {
    m_fn = NULL;
    m_inst = inst;
    m_member = member;
    m_caller = &EventCallback::memberCaller<T>;
  }


private:
  void callback(target_event event);

  //Function
  void(*m_fn)(NFCEvent, void*);
  void* m_arg;

  //Member of object instance
  void* m_inst;
  void* m_member;
  void* (*m_caller)(NFCEvent);

  template <class T>
  static inline void memberCaller(NFCEvent event)
  {
    T* inst = (T*) m_inst;
    void (T::*member)(NFCEvent) = m_member;
    inst->member(event);
  }

  static void staticCallback(target_event event, void* param);

  friend class MuNFC;
};



#endif /* EVENTCALLBACK_H_ */
