/*
    event.h 
    Copyright (c) Donatien Garnier 2012
    donatien.garnier@appnearme.com
    http://www.appnearme.com/
*/


#ifndef EVENT_H_
#define EVENT_H_

#ifdef __cplusplus
extern "C" {
#endif

#include "core/fwk.h"

typedef enum __target_event
{
  TRANSACTION_STARTED, //< Transaction with reader started (anticollision successful)
  TRANSACTION_SUCCESSFUL, //< Transaction with reader successful
  TRANSACTION_FAILED //< Transaction with reader failed
} target_event;

typedef void (*target_event_callback)(target_event event, void* param);

void target_event_init(void);

void target_register_event_callback(target_event_callback cb, void* param);

void target_fire_event(target_event event);

#ifdef __cplusplus
}
#endif

#endif /* EVENT_H_ */
